from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, String

Cap3_V0_1_0 = CommandToolBuilder(tool="cap3", base_command=["cap3"], inputs=[ToolInput(tag="in_n_specify_size", input_type=Boolean(optional=True), prefix="-a", doc=InputDocumentation(doc="N  specify band expansion size N > 10 (20)")), ToolInput(tag="in_n_specify_differences", input_type=Boolean(optional=True), prefix="-b", doc=InputDocumentation(doc="N  specify base quality cutoff for differences N > 15 (20)")), ToolInput(tag="in_n_clipping_n", input_type=Boolean(optional=True), prefix="-c", doc=InputDocumentation(doc="N  specify base quality cutoff for clipping N > 5 (12)")), ToolInput(tag="in_n_specify_sum", input_type=Boolean(optional=True), prefix="-d", doc=InputDocumentation(doc="N  specify max qscore sum at differences N > 20 (200)")), ToolInput(tag="in_n_specify_clearance", input_type=Boolean(optional=True), prefix="-e", doc=InputDocumentation(doc="N  specify clearance between no. of diff N > 10 (30)")), ToolInput(tag="in_n_specify_length", input_type=Boolean(optional=True), prefix="-f", doc=InputDocumentation(doc="N  specify max gap length in any overlap N > 1 (20)")), ToolInput(tag="in_n_specify_gap_factor", input_type=Boolean(optional=True), prefix="-g", doc=InputDocumentation(doc="N  specify gap penalty factor N > 0 (6)")), ToolInput(tag="in_n_specify_pair", input_type=Boolean(optional=True), prefix="-i", doc=InputDocumentation(doc="N  specify segment pair score cutoff N > 20 (40)")), ToolInput(tag="in_n_specify_chain_score_cutoff", input_type=Boolean(optional=True), prefix="-j", doc=InputDocumentation(doc="N  specify chain score cutoff N > 30 (80)")), ToolInput(tag="in_n_specify_end", input_type=Boolean(optional=True), prefix="-k", doc=InputDocumentation(doc="N  specify end clipping flag N >= 0 (1)")), ToolInput(tag="in_n_specify_match_factor", input_type=Boolean(optional=True), prefix="-m", doc=InputDocumentation(doc="N  specify match score factor N > 0 (2)")), ToolInput(tag="in_n_specify_mismatch", input_type=Boolean(optional=True), prefix="-n", doc=InputDocumentation(doc="N  specify mismatch score factor N < 0 (-5)")), ToolInput(tag="in_n_specify_length_cutoff", input_type=Boolean(optional=True), prefix="-o", doc=InputDocumentation(doc="N  specify overlap length cutoff > 15 (40)")), ToolInput(tag="in_n_specify_percent_cutoff", input_type=Boolean(optional=True), prefix="-p", doc=InputDocumentation(doc="N  specify overlap percent identity cutoff N > 65 (90)")), ToolInput(tag="in_n_specify_value", input_type=Boolean(optional=True), prefix="-r", doc=InputDocumentation(doc="N  specify reverse orientation value N >= 0 (1)")), ToolInput(tag="in_n_specify_similarity_score_cutoff", input_type=Boolean(optional=True), prefix="-s", doc=InputDocumentation(doc="N  specify overlap similarity score cutoff N > 250 (900)")), ToolInput(tag="in_n_specify_number", input_type=Boolean(optional=True), prefix="-t", doc=InputDocumentation(doc="N  specify max number of word matches N > 30 (300)")), ToolInput(tag="in_n_specify_correction", input_type=Boolean(optional=True), prefix="-u", doc=InputDocumentation(doc="N  specify min number of constraints for correction N > 0 (3)")), ToolInput(tag="in_n_linking_n", input_type=Boolean(optional=True), prefix="-v", doc=InputDocumentation(doc="N  specify min number of constraints for linking N > 0 (2)")), ToolInput(tag="in_n_specify_name", input_type=Boolean(optional=True), prefix="-w", doc=InputDocumentation(doc="N  specify file name for clipping information (none)")), ToolInput(tag="in_n_specify_string", input_type=File(optional=True), prefix="-x", doc=InputDocumentation(doc="N  specify prefix string for output file names (cap)")), ToolInput(tag="in_n_specify_clipping", input_type=Boolean(optional=True), prefix="-y", doc=InputDocumentation(doc="N  specify clipping range N > 5 (100)")), ToolInput(tag="in_n_specify_min", input_type=Boolean(optional=True), prefix="-z", doc=InputDocumentation(doc="N  specify min no. of good reads at clip pos N > 0 (3)")), ToolInput(tag="in_file_of_reads", input_type=String(), position=0, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_n_specify_string", output_type=File(optional=True), selector=InputSelector(input_to_select="in_n_specify_string", type_hint=File()), doc=OutputDocumentation(doc="N  specify prefix string for output file names (cap)"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Cap3_V0_1_0().translate("wdl", allow_empty_container=True)

